import { PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrClasscourse {
  [PrimaryKeyProp]?: 'Id';
  Id!: bigint;
  ClassRoomCourseId!: bigint;
  SchoolId?: bigint;
  GradeId?: bigint;
  ClassId!: bigint;
  Type!: number;
  Remark?: string;
  Revision!: number;
  CreatedBy?: bigint;
  CreatedTime!: Date;
  UpdatedBy?: bigint;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const IcrClasscourseSchema = defineEntity({
  class: IcrClasscourse,
  comment: '课程班级关系(云班)',
  properties: {
    Id: p.bigint().primary().name('Id').unsigned(false).autoincrement(false).comment('主键Id'),
    ClassRoomCourseId: p.bigint().name('ClassRoomCourseId').comment('课程课程Id').index('idx_ICR_ClassCourse_01'),
    SchoolId: p.bigint().name('SchoolId').nullable().comment('授课学校id'),
    GradeId: p.bigint().name('GradeId').nullable().comment('授课年级id'),
    ClassId: p.bigint().name('ClassId').comment('班级'),
    Type: p.integer().name('Type').comment('班级类型;1 本班 2 云班'),
    Remark: p.string().name('Remark').nullable().comment('备注'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
